(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('ng-rapi', ['exports', '@angular/core', '@angular/common/http'], factory) :
    (factory((global['ng-rapi'] = {}),global.ng.core,global.ng.common.http));
}(this, (function (exports,i0,i1) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?=} transformers
     * @return {?}
     */
    function reduceRequest(transformers) {
        if (transformers === void 0) {
            transformers = [];
        }
        return function (requestData) {
            return transformers.reduce(function (transformedRequest, transformer) {
                transformedRequest = transformer(transformedRequest);
                return transformedRequest;
            }, requestData);
        };
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} params
     * @return {?}
     */
    function normalizeParams(params) {
        if (!params) {
            return new i1.HttpParams();
        }
        if (params instanceof i1.HttpParams) {
            return params;
        }
        return Object.entries(params)
            .reduce(function (httpParams, entry) {
            var _a = __read(entry, 2), key = _a[0], param = _a[1];
            return httpParams.append(key, param.toString());
        }, new i1.HttpParams());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?=} options
     * @return {?}
     */
    function normalizeOptions(options) {
        if (options === void 0) {
            options = {};
        }
        return __assign({}, options, { params: normalizeParams(options.params), headers: new i1.HttpHeaders(options.headers) });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} transformers
     * @return {?}
     */
    function transformRequest(transformers) {
        /** @type {?} */
        var reduceRequestTransformers = reduceRequest(transformers);
        return function (request) {
            /** @type {?} */
            var normalizedRequest = {
                body: request.body,
                options: normalizeOptions(request.options),
            };
            return reduceRequestTransformers(normalizedRequest);
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Api = /** @class */ (function () {
        function Api(http, config) {
            this.http = http;
            this.config = config;
            this.transformRequest = function (request) { return request; };
            this.http = http;
            this.config = config;
            this.baseUrl = this.config.urls[this.config.environment];
            this.transformRequest = transformRequest(this.config.transformers);
        }
        /**
         * @private
         * @param {?} path
         * @return {?}
         */
        Api.prototype.getUrl = /**
         * @private
         * @param {?} path
         * @return {?}
         */
            function (path) {
                return "" + this.baseUrl + path;
            };
        /**
         * @param {?} path
         * @param {?} options
         * @return {?}
         */
        Api.prototype.get = /**
         * @param {?} path
         * @param {?} options
         * @return {?}
         */
            function (path, options) {
                /** @type {?} */
                var url = this.getUrl(path);
                /** @type {?} */
                var preparedRequest = this.transformRequest({ options: options });
                return this.http.get(url, preparedRequest.options);
            };
        /**
         * @param {?} path
         * @param {?} body
         * @param {?} options
         * @return {?}
         */
        Api.prototype.post = /**
         * @param {?} path
         * @param {?} body
         * @param {?} options
         * @return {?}
         */
            function (path, body, options) {
                /** @type {?} */
                var url = this.getUrl(path);
                /** @type {?} */
                var preparedRequest = this.transformRequest({ body: body, options: options });
                return this.http.post(url, preparedRequest.body, preparedRequest.options);
            };
        /**
         * @param {?} path
         * @param {?} body
         * @param {?} options
         * @return {?}
         */
        Api.prototype.put = /**
         * @param {?} path
         * @param {?} body
         * @param {?} options
         * @return {?}
         */
            function (path, body, options) {
                /** @type {?} */
                var url = this.getUrl(path);
                /** @type {?} */
                var preparedRequest = this.transformRequest({ body: body, options: options });
                return this.http.put(url, preparedRequest.body, preparedRequest.options);
            };
        /**
         * @param {?} path
         * @param {?} options
         * @return {?}
         */
        Api.prototype.delete = /**
         * @param {?} path
         * @param {?} options
         * @return {?}
         */
            function (path, options) {
                /** @type {?} */
                var url = this.getUrl(path);
                /** @type {?} */
                var preparedRequest = this.transformRequest({ options: options });
                return this.http.delete(url, preparedRequest.options);
            };
        return Api;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ApiBuilderService = /** @class */ (function () {
        function ApiBuilderService(http) {
            this.http = http;
        }
        /**
         * @param {?} config
         * @return {?}
         */
        ApiBuilderService.prototype.build = /**
         * @param {?} config
         * @return {?}
         */
            function (config) {
                return new Api(this.http, config);
            };
        ApiBuilderService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ApiBuilderService.ctorParameters = function () {
            return [
                { type: i1.HttpClient }
            ];
        };
        /** @nocollapse */ ApiBuilderService.ngInjectableDef = i0.defineInjectable({ factory: function ApiBuilderService_Factory() { return new ApiBuilderService(i0.inject(i1.HttpClient)); }, token: ApiBuilderService, providedIn: "root" });
        return ApiBuilderService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ApiBuilderService = ApiBuilderService;
    exports.Api = Api;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ng-rapi.umd.js.map